unit MMTimer;

{ Copyright (c) 2006 tadashi.ikoma, All rights reserved. }
{ Interval ́@ŏlAőlm肽ꍇ́A
vOŁAMin,Max̒lǂݏoĂB}
{\ Resolution ̒ǉ TimeGetTime ̕\ɂêŒӂ鎖}

interface

uses
  SysUtils, WinTypes, Classes,MMSystem;

type

  EMMTimerError = class(Exception);
  TMMTimer = class(TComponent)
  private
    FID: Cardinal;
    FInterval: Cardinal;
    FResolution: Cardinal;
    FOnTimer: TNotifyEvent;
    FEnabled: Boolean;
    TMinMax: TIMECAPS;
    procedure UpdateTimer;
    procedure SetEnabled(Value: Boolean);
    procedure SetInterval(Value: Cardinal);
    procedure SetResolution(Value: Cardinal);
  protected
//    procedure Timer; dynamic;
    procedure Loaded; override;
  public
    Min: Cardinal;
    Max: Cardinal;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Enabled: Boolean read FEnabled write SetEnabled default True;
    property Interval: Cardinal read FInterval write SetInterval default 1000;
    property Resolution: Cardinal read FResolution write SetResolution default 1;
    property OnTimer: TNotifyEvent read FOnTimer write FOnTimer;
  end;

procedure Register;

implementation

uses ShellAPI, Registry;


procedure MMTimerProc(ID, Reserved: Cardinal;
                      dwUser, dwReserved1, dwReserved2: NativeUint); stdcall;
begin
//  TMMTimer(dwUser).Timer;
  if Assigned(TMMTimer(dwUser).Ontimer) then TMMTimer(dwUser).OnTimer(TMMTimer(dwUser));
end;

constructor TMMTimer.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FEnabled := True;
  FInterval := 1000;
//^C}[foCX̐\擾
  TimeGetDevCaps(@TMinMax,sizeof(TMinMax));
  Min := TMinMax.wPeriodMin;
  Max := TMinMax.wPeriodMax;
  FResolution := Min;
end;

procedure TMMTimer.Loaded;
begin
  inherited Loaded;
  UpdateTimer;
end;

destructor TMMTimer.Destroy;
begin
  FEnabled := False;
  UpdateTimer;
  inherited Destroy;
end;

procedure TMMTimer.UpdateTimer;
begin
  if FID <> 0 then timeKillEvent(FID);
  if FEnabled and Assigned(FOnTimer) then
    begin
      if FInterval >= FResolution then
        begin
          FID := timeSetEvent(FInterval, FResolution, MMTimerProc, DWORD(Self), TIME_PERIODIC);
          if FID = 0 then
            begin
              FEnabled := False;
              raise EMMTimerError.Create('No MMTimer Available');
            end;
        end
        else
        begin
          FEnabled := False;
          raise EMMTimerError.Create('a Large Resolution of MMTimer');
        end;
  end;
end;

{procedure TMMTimer.Timer;
begin
  if Assigned(FOnTimer) then
    FOnTimer(Self);
end;}

procedure TMMTimer.SetEnabled(Value: Boolean);
begin
  if FEnabled <> Value then
  begin
    FEnabled := Value;
    UpdateTimer;
  end;
end;

procedure TMMTimer.SetInterval(Value: Cardinal);
begin
  if FInterval <> Value then
  begin
//^C}[͈̔͂𒴂Đݒ肵AG[\
    if Min > Value then
        begin
            raise EMMTimerError.Create('time under' + #13#10 +
                                        'minimum '+ intTostr(Min));
            exit;
        end;
    if Max < Value then
        begin
            raise EMMTimerError.Create('time over' + #13#10 +
                                        'maximum ' + intTostr(Max));
            exit;
        end;
    FInterval := Value;
    UpdateTimer;
  end;
end;

procedure TMMTimer.SetResolution(Value: Cardinal);
begin
  if FResolution <> Value then
  begin
//^C}[̕\𒴂Đݒ肵A^C}[\C
    if Min > Value then FResolution := Min
                   else FResolution := Value;
    UpdateTimer;
  end;
end;

procedure Register;
begin
  RegisterComponents('MMTimer', [TMMTimer]);
end;

end.
