unit StopWatch;

interface

uses
  Windows, SysUtils, Classes;

type
  TStopWatch = class(TComponent)
  private
    { Private 錾 }
    FFrequency: int64;
    FStart:     int64;
    FStop:      int64;
  protected
    { Protected 錾 }
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Start;
    function Stop: extended;
  published
    { Published 錾 }
  end;

procedure Register;

implementation


constructor TStopWatch.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  QueryPerformanceFrequency(FFrequency);
end;

destructor TStopWatch.Destroy;
begin
  inherited;
end;

procedure TStopWatch.Start;
begin
  QueryPerformanceCounter(FStart);
end;

function TStopWatch.Stop: extended;
begin
  QueryPerformanceCounter(FStop);
  result := (FStop - FStart) * 1000 / FFrequency;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TStopWatch]);
end;

end.

